/* ***************************************************************** *
 * Copyright 1998 International Business Machines Corporation. All   *
 * Rights Reserved.                                                  *
 *                                                                   *
 * Please read this carefully.  Your use of this reference           *
 * implementation of certain of the IETF public-key infrastructure   *
 * specifications ("Software") indicates your acceptance of the      *
 * following.  If you do not agree to the following, do not install  *
 * or use any of the Software.                                       *
 *                                                                   *
 * Permission to use, reproduce, distribute and create derivative    *
 * works from the Software ("Software Derivative Works"), and to     *
 * distribute such Software Derivative Works is hereby granted to    *
 * you by International Business Machines Corporation ("IBM").  This *
 * permission includes a license under the patents of IBM that are   *
 * necessarily infringed by your use of the Software as provided by  *
 * IBM.                                                              *
 *                                                                   *
 * IBM licenses the Software to you on an "AS IS" basis, without     *
 * warranty of any kind.  IBM HEREBY EXPRESSLY DISCLAIMS ALL         *
 * WARRANTIES OR CONDITIONS, EITHER EXPRESS OR IMPLIED, INCLUDING,   *
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OR CONDITIONS OF       *
 * MERCHANTABILITY, NON INFRINGEMENT AND FITNESS FOR A PARTICULAR    *
 * PURPOSE.  You are solely responsible for determining the          *
 * appropriateness of using this Software and assume all risks       *
 * associated with the use of this Software, including but not       *
 * limited to the risks of program errors, damage to or loss of      *
 * data, programs or equipment, and unavailability or interruption   *
 * of operations.                                                    *
 *                                                                   *
 * IBM WILL NOT BE LIABLE FOR ANY DIRECT DAMAGES OR FOR ANY SPECIAL, *
 * INCIDENTAL, OR  INDIRECT DAMAGES OR FOR ANY ECONOMIC              *
 * CONSEQUENTIAL DAMAGES (INCLUDING LOST PROFITS OR SAVINGS), EVEN   *
 * IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  IBM  *
 * will not be liable for the loss of, or damage to, your records or *
 * data, or any damages claimed by you based on a third party claim. *
 *                                                                   *
 * IBM wishes to obtain your feedback to assist in improving the     *
 * Software.  You grant IBM a world-wide, royalty-free right to use, *
 * copy, distribute, sublicense and prepare derivative works based   *
 * upon any feedback, including materials, error corrections,        *
 * Software Derivatives, enhancements, suggestions and the like that *
 * you provide to IBM relating to the Software (this does not        *
 * include products for which you charge a royalty and distribute to *
 * IBM under other terms and conditions).                            *
 *                                                                   *
 * You agree to distribute the Software and any Software Derivatives *
 * under a license agreement that: 1) is sufficient to notify all    *
 * licensees of the Software and Software Derivatives that IBM       *
 * assumes no liability for any claim that may arise regarding the   *
 * Software or Software Derivatives, and 2) that disclaims all       *
 * warranties, both express and implied, from IBM regarding the      *
 * Software and Software Derivatives.  (If you include this          *
 * Agreement with any distribution of the Software or Software       *
 * Derivatives you will have met this requirement.)  You agree that  *
 * you will not delete any copyright notices in the Software.        *
 *                                                                   *
 * This Agreement is the exclusive statement of your rights in the   *
 * Software as provided by IBM.   Except for the rights granted to   *
 * you in the second paragraph above, You are not granted any other  *
 * patent rights, including but not limited to the right to make     *
 * combinations of the Software with products that infringe IBM      *
 * patents. You agree to comply with all applicable laws and         *
 * regulations, including all export and import laws and regulation. *
 * This Agreement is governed by the laws of the State of New York.  *
 * This Agreement supersedes all other communications,               *
 * understandings or agreements we may have had prior to this        *
 * Agreement.                                                        *
 * ***************************************************************** */

#include "exception.hpp"
#include "cssmerr.h"
#include "misc.hpp"

#include "cipher.hpp"
#include "sign.hpp"
#include "digest.hpp"
#include "random.hpp"
#include "keygen.hpp"
#include "dhderive.hpp"

#include "ibmcylinkcsp.hpp"
#include "session.hpp"

/**********************************************************
 *
 *	Session class
 *
 **********************************************************/
Session::Session(CSSM_MODULE_HANDLE _cspHandle, CSSM_SPI_MEMORY_FUNCS* _memFuncs) {
	cspHandle = _cspHandle;
	memcpy(&memFuncs, _memFuncs, sizeof(CSSM_SPI_MEMORY_FUNCS));
	head = NULL;
	next = NULL;
}

Session::~Session() {
	if (head != NULL)
		Close();
}

void Session::Close() {
	//Closes all open contexts
	Context	*context, *next;

	for (context = head; context != NULL; context = next) {
		next = context->next;
		delete context;
	}

	head = NULL;
}

void Session::AddContext(Context* context) {
	if (context == NULL)
		throw InputException(CSSM_CSP_INVALID_CONTEXT_POINTER);

	context->next = head;
	head = context;
}

Context* Session::GetContext(uint32 ctxHandle) {
	Context *tmp = head;

	while (tmp != NULL) {
		if (tmp->getHandle() == ctxHandle)
			return (tmp);

		if (tmp->next == NULL)
			//return(NULL);
			throw InputException(CSSM_CSP_INVALID_CONTEXT_HANDLE);

		tmp = tmp->next;
	}

	throw InputException(CSSM_CSP_INVALID_CONTEXT_HANDLE);
	return(NULL);
}

void Session::RemoveContext(Context* context) {
	Context	*current, *prev;

	if (context == NULL)
		throw InputException(CSSM_CSP_INVALID_CONTEXT_POINTER);

	for (current = head, prev = NULL; current != NULL; prev = current, current = current->next) {
		if (current == context) {
			if (current == head)
				head = current->next;
			else
				prev->next = current->next;

			delete current;
			return;
		}
	}
/*	Context *tmp = head, *previous = NULL;
	while (tmp != NULL) {
		if (tmp == context) {
			if (previous != NULL) {
				previous->next = tmp->next;
			}
			else {
				head = NULL;
			}
			delete tmp;
			tmp = NULL;
			return;
		}
		previous = tmp;
		tmp = tmp->next;
	}*/

	//context not found
	throw InputException(CSSM_CSP_INVALID_CONTEXT_POINTER);
}

void Session::RemoveContext(uint32 ctxHandle) {
	Context *context, *prev;

	for (context = head, prev = NULL; context != NULL; prev = context, context = context->next) {
		if (context->getHandle() == ctxHandle) {
			if (context == head)
				head = context->next;
			else
				prev->next = context->next;

			delete context;
			return;
		}
	}

	//context not found
	throw InputException(CSSM_CSP_INVALID_CONTEXT_HANDLE);
}

Context* Session::CreateContext(uint32 ctxHandle, uint32 type, uint32 algId, uint32 mode) {
	switch(type) {
	case CSSM_ALGCLASS_SYMMETRIC:
		return(new Cipher(ctxHandle, algId, mode));
		break;
	case CSSM_ALGCLASS_KEYGEN:
		return(new KeyGen(ctxHandle, algId, NULL));
		break;
	case CSSM_ALGCLASS_SIGNATURE:
		return(new Sign(ctxHandle, algId));
		break;
	case CSSM_ALGCLASS_DIGEST:
		return(new Digest(ctxHandle, algId));
		break;
	case CSSM_ALGCLASS_RANDOMGEN:
		return(new Random(ctxHandle, algId));
		break;
	case CSSM_ALGCLASS_DERIVEKEY:
		//I believe algId is DH! -> check!!!
		return(new DHDeriveKey(ctxHandle, algId));
		break;
	default:
		throw InputException(CSSM_CSP_OPERATION_UNSUPPORTED);
		break;
	}

	return(NULL);
}

uint8* Session::malloc(uint32 size) {
	if (size == 0)
		return(NULL);

	uint8* ptr = (uint8*)memFuncs.malloc_func(cspHandle, size);
	if (ptr == NULL)
		throw MemoryException(CSSM_MALLOC_FAILED);

	return(ptr);
}

uint8* Session::calloc(uint32 num, uint32 size) {
	uint8* ptr = (uint8*)memFuncs.calloc_func(cspHandle, num, size);
	if (ptr == NULL)
		throw MemoryException(CSSM_CALLOC_FAILED);

	return(ptr);
}

uint8* Session::realloc(uint8* memblock, uint32 size) {
	uint8* ptr = (uint8*)memFuncs.realloc_func(cspHandle, (void*)memblock, size);
	if (ptr == NULL)
		throw MemoryException(CSSM_REALLOC_FAILED);

	return(ptr);
}

void Session::free(uint8* memblock) {
	memFuncs.free_func(cspHandle, (void*)memblock);
	memblock = NULL;
}
